package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        if (size() > 0) return false;
        return true;
    }

    @Override
    public Cart get(User key) {
        for (Entry e : entries) {
            if (e.getKey().equals(key)) return e.getValue();
        }
        return null;
    }

    @Override
    public void put(User key, Cart value) {
        boolean contains = false;
        for (Entry e : entries)
            if (e.getKey().equals(key)) {
                e.setValue(value);
                contains = true;
                break;
            }
        if (contains == false) entries.add(new Entry(key, value));
    }


    @Override
    public List<User> getKeys() {
        List<User> list = new ArrayList<>();
        entries.forEach(e ->list.add(e.getKey()));
        return list;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> list = new ArrayList<>();
        entries.forEach(e ->list.add(e.getValue()));
        return list;
    }

    @Override
    public Cart remove(User key) {
        //remove and return cart
        for (Entry e : entries)
            if (e.getKey().equals(key)){
                Cart c = e.getValue();
                e.setValue(null);
                return c;
            }
        return null;
    }
}
