package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        int size = 0;
        for(List<Entry> l : entries){
            size+=l.size();
        }
        return size;
    }

    @Override
    public boolean isEmptry() {
        if (size() > 0) return false;
        return true;
    }

    @Override
    public Cart get(User key) {
        for (Entry e : entries[bucketIndex(key)]){
            if (e.getKey().equals(key)) return e.getValue();
        }
        return null;
    }

    @Override
    public void put(User key, Cart value) {
        boolean contains = false;
        List<Entry> l = entries[bucketIndex(key)];

        for (Entry e : l)
            if (e.getKey().equals(key)) {
                e.setValue(value);
                contains = true;
                break;
            }
        if (contains == false) l.add(new Entry(key, value));
    }

    @Override
    public List<User> getKeys() {
        List<User> list = new ArrayList<>();
        for(List<Entry> l : entries)
            l.forEach(e -> list.add(e.getKey()));
        return list;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> list = new ArrayList<>();
        for(List<Entry> l : entries)
            l.forEach(e -> list.add(e.getValue()));
        return list;
    }

    @Override
    public Cart remove(User key) {
        for (Entry e : entries[bucketIndex(key)])
            if (e.getKey().equals(key)){
                Cart c = e.getValue();
                e.setValue(null);
                return c;
            }
        return null;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
